#include <iostream>
using namespace std;

// this kernel just wastes some time
__global__ void kernelA(unsigned int *d_out, unsigned int count)
    {
    unsigned int a = 0;
    
    for (unsigned int i = 0; i < count; i++)
        a += i;

    if (threadIdx.x && blockIdx.x == 0)
        *d_out = a;
    }

// this is the same as kernelA, but with a different name so that it shows up in the profiler better
__global__ void kernelB(unsigned int *d_out, unsigned int count)
    {
    unsigned int a = 0;
    
    for (unsigned int i = 0; i < count; i++)
        a += i;

    if (threadIdx.x && blockIdx.x == 0)
        *d_out = a;
    }

int main(int argc, char **argv)
    {
    if (argc != 4)
        {
        cout << "usage: test_cudathreadsyncrhonize a delay flag" << endl;
        exit(1);
        }

    unsigned int a = atoi(argv[1]), nloop = 1000, delay=atoi(argv[2]);
    unsigned int flag = atoi(argv[3]);
    unsigned int nthread=160, nblocks=256;
    unsigned int *d_out;
    cudaMalloc(&d_out, sizeof(unsigned int));
    unsigned int t;
    
    for (unsigned int loop=0; loop < nloop; loop++)
        {
        kernelB<<<nblocks, nthread>>>(d_out, delay);

        for (unsigned int i = 0; i < a; i++)
            kernelA<<<nblocks, nthread>>>(d_out, delay);
        
        if (flag)
            cudaThreadSynchronize();
        else
            cudaMemcpy(&t, d_out, sizeof(unsigned int), cudaMemcpyDeviceToHost);
        }

    cudaFree(d_out);
    }
